SystemOrganization addCategory: #'Magritte-Scriptaculous'!

MAListCompositonComponent subclass: #MAListCompositonComponentSU
	instanceVariableNames: 'id availableId selectedId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
formId

	^ self labelId, '-f'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorAvailableOn: html

	html select
		attributes: self attributes;
		id: availableId;
		size: 6; style: 'width: 250px';
		list: self availableList;
		selected: self availableSelected;
		callback: [ :value | self availableSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonAddOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: availableId;
					callback: [ :r | self add; updateEditorOn: r ];
					return: false);
		with: '>>'.
	html break.
	html button
		onClick: (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self remove; updateEditorOn: r ];
					return: false);
		with: '<<'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:18'!
renderEditorButtonOrderOn: html

	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveUp; updateEditorOn: r ];
					return: false);
		text: 'up'.
	html break.
	html button
		onClick:  (html updater
					id: id;
					triggerFormElement: selectedId;
					callback: [ :r | self moveDown; updateEditorOn: r ]; 
					return: false);
		text: 'down'! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/26/2007 17:13'!
renderEditorOn: html 
	id := html nextId.
	availableId := html nextId.
	selectedId := html nextId.
	html div
		id: id;
		with: 
			 [self updateEditorOn: html] ! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 11/13/2007 23:54'!
renderEditorSelectedOn: html
 	html select
		attributes: self attributes;
		id: selectedId;
		size: 6; style: 'width: 250px';
		list: self selectedList;
		selected: self selectedSelected;
		callback: [ :value | self selectedSelected: value ];
		labels: [ :value | self labelForOption: value ]! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/16/2007 08:56'!
updateEditorOn: html
		super renderEditorOn: html! !

!MAListCompositonComponentSU methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 10:26'!
updateId

	^ self labelId, '-u'! !

MATextInputComponent subclass: #MAAutoCompletingTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Scriptaculous'!

!MAAutoCompletingTextInputComponent commentStamp: 'kph 11/20/2007 00:12' prior: 0!
At present we obtain the list from the model, via the accessor supplied at:, #listAccessor
we can alternatively get it from the memento via a description obtained from the model class, #listDescriptionSelector

We also have an #inputExampleText property (as an addition to our superclass)

and #listMax!

!MAAutoCompletingTextInputComponent class methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 04:32'!
isAbstract

 ^ false! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:27'!
list

	self listDescription ifNotNilDo: [ :desc | ^ self memento readUsing: desc  ].
	 
	self listModelAccessor ifNotNilDo: [ :accessor | ^ accessor read: self memento model  ].

	self error: 'see class comment for properties which need to be configured'.
! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:23'!
listDescription

	^ self memento model class perform: (self listDescriptionSelector ifNil:[ ^nil ])! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:21'!
listDescriptionSelector

	^ self description propertyAt: #listDescriptionSelector ifAbsent: nil! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:11'!
listMax
	^ self description propertyAt: #listMax ifAbsent: [ self listMaxDefault ]! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:12'!
listMaxDefault
	^  10! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 20:20'!
listModelAccessor

	^ self description propertyAt: #listAccessor! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 23:04'!
renderEditorOn: html
	| input |

 

	input := self labelId.
	html textInput
		attributes: self attributes;
		id: input;
		value: self string;
		exampleText: self exampleText;
		callback: [ :v | self string: v ].
		
	html div 
		class: 'autocomplete';
		script: (html autocompleter
		element: input;
		onSelected: (html request
					triggerFormElement: 'text');
		on: #renderListOn: of: self)
		 ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 00:12'!
renderListOn: html
	| items |
	
	items := self list select: [ :each | each name includesSubstring: self string caseSensitive: false ].

	html unorderedList list: (items first: (items size min: self listMax))! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 08:33'!
selectionHandlerOn: html ! !

!MAAutoCompletingTextInputComponent methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 22:19'!
style
	^ 'input#text {
	width: 250px;
}
div.autocomplete {
	position: absolute;
	background-color: white;
	border: 1px solid #888;
	margin: 0px;
	padding: 0px;
	z-index: 1000;
}
div.autocomplete ul, div.autocomplete ul li {
	list-style-type: none;
	line-height: 1.7;
	margin: 0px;
	padding: 0px;
}
div.autocomplete ul li.selected {
	background-color: #ffb;
}'! !

!MATextInputComponent methodsFor: '*magritte-scriptaculous' stamp: 'kph 11/19/2007 23:08'!
exampleText

	^ self description propertyAt: #inputExampleText ifAbsent: ['']! !

!MATextInputComponent methodsFor: '*magritte-scriptaculous-overide' stamp: 'kph 11/19/2007 23:08'!
renderEditorOn: html
	html textInput
		attributes: self attributes;
		id: self labelId;
		value: self string;
		exampleText: self exampleText;
		callback: [ :s | self string: s ].! !
